def project = 'opticca-k8s-testbed'
def  appName = 'myapp'
def  feSvcName = "starhopper"
def  imageTag = "gcr.io/${project}/${appName}:build-${env.BUILD_NUMBER}"

pipeline {
  agent {
    kubernetes {
      label 'myapp'
      defaultContainer 'jnlp'
      yaml """
apiVersion: v1
kind: Pod
metadata:
labels:
  component: ci
spec:
  # Use service account that can deploy to all namespaces
  serviceAccountName: cd-jenkins
  containers:
  - name: gcloud
    image: gcr.io/cloud-builders/gcloud
    command:
    - cat
    tty: true
  - name: kubectl
    image: gcr.io/cloud-builders/kubectl
    command:
    - cat
    tty: true
"""
}
  }
  
  
  
  stages {
    stage('Preflight-checks') {
            steps {
                sh 'git --version'
                sh 'javac -version'
                sh 'java -version'
            }
        }

       stage('Build and push image with Container Builder') {
      steps {
        container('gcloud') {
          sh "PYTHONBUFFERED=1 gcloud builds submit -t ${imageTag} ."
        }
      }
    }
      
     stage('Deploy Production') {
      // Production branch
      when { branch 'master' }
      steps{
        container('kubectl') {
        // Change deployed image in canary to the one we just built
          sh("sed -i.bak 's#gcr.io/opticca-k8s-testbed/myapp:build-8#${imageTag}#' hello-app-kube.yml")
          echo 'yaml file read successfully'
          sh("kubectl apply -f hello-app-kube.yml")
          echo 'kubecl get svc'
          sh("echo http://`kubectl --namespace=default get service/${feSvcName} -o jsonpath='{.status.loadBalancer.ingress[0].ip}'` > ${feSvcName}")
        }
      }
    }  
}
}